Merge branch 'kb/maint-diff-ws-check' into maint
[git/dscho.git] / t / test-lib.sh
blobc6afebb00d02808f2a990347c8b0479d825cce5b
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22 # do not redirect again
24 *' --tee '*|*' --va'*)
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
81 unset CDPATH
83 unset GREP_OPTIONS
85 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86 1|2|true)
87 echo "* warning: Some tests will not work if GIT_TRACE" \
88 "is set as to trace on STDERR ! *"
89 echo "* warning: Please set GIT_TRACE to something" \
90 "other than 1, 2 or true ! *"
92 esac
94 # Convenience
96 # A regexp to match 5 and 40 hexdigits
97 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
100 # Each test should start with something like this, after copyright notices:
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107 TERM=$ORIGINAL_TERM &&
108 export TERM &&
109 [ -t 1 ] &&
110 tput bold >/dev/null 2>&1 &&
111 tput setaf 1 >/dev/null 2>&1 &&
112 tput sgr0 >/dev/null 2>&1
113 ) &&
114 color=t
116 while test "$#" -ne 0
118 case "$1" in
119 -d|--d|--de|--deb|--debu|--debug)
120 debug=t; shift ;;
121 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122 immediate=t; shift ;;
123 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125 -h|--h|--he|--hel|--help)
126 help=t; shift ;;
127 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128 verbose=t; shift ;;
129 -q|--q|--qu|--qui|--quie|--quiet)
130 # Ignore --quiet under a TAP::Harness. Saying how many tests
131 # passed without the ok/not ok details is always an error.
132 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
133 --with-dashes)
134 with_dashes=t; shift ;;
135 --no-color)
136 color=; shift ;;
137 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138 valgrind=t; verbose=t; shift ;;
139 --tee)
140 shift ;; # was handled already
141 --root=*)
142 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143 shift ;;
145 echo "error: unknown test option '$1'" >&2; exit 1 ;;
146 esac
147 done
149 if test -n "$color"; then
150 say_color () {
152 TERM=$ORIGINAL_TERM
153 export TERM
154 case "$1" in
155 error) tput bold; tput setaf 1;; # bold red
156 skip) tput bold; tput setaf 2;; # bold green
157 pass) tput setaf 2;; # green
158 info) tput setaf 3;; # brown
159 *) test -n "$quiet" && return;;
160 esac
161 shift
162 printf "%s" "$*"
163 tput sgr0
164 echo
167 else
168 say_color() {
169 test -z "$1" && test -n "$quiet" && return
170 shift
171 echo "$*"
175 error () {
176 say_color error "error: $*"
177 GIT_EXIT_OK=t
178 exit 1
181 say () {
182 say_color info "$*"
185 test "${test_description}" != "" ||
186 error "Test script did not set test_description."
188 if test "$help" = "t"
189 then
190 echo "$test_description"
191 exit 0
194 exec 5>&1
195 if test "$verbose" = "t"
196 then
197 exec 4>&2 3>&1
198 else
199 exec 4>/dev/null 3>/dev/null
202 test_failure=0
203 test_count=0
204 test_fixed=0
205 test_broken=0
206 test_success=0
208 test_external_has_tap=0
210 die () {
211 code=$?
212 if test -n "$GIT_EXIT_OK"
213 then
214 exit $code
215 else
216 echo >&5 "FATAL: Unexpected exit with code $code"
217 exit 1
221 GIT_EXIT_OK=
222 trap 'die' EXIT
224 # The semantics of the editor variables are that of invoking
225 # sh -c "$EDITOR \"$@\"" files ...
227 # If our trash directory contains shell metacharacters, they will be
228 # interpreted if we just set $EDITOR directly, so do a little dance with
229 # environment variables to work around this.
231 # In particular, quoting isn't enough, as the path may contain the same quote
232 # that we're using.
233 test_set_editor () {
234 FAKE_EDITOR="$1"
235 export FAKE_EDITOR
236 EDITOR='"$FAKE_EDITOR"'
237 export EDITOR
240 test_decode_color () {
241 awk '
242 function name(n) {
243 if (n == 0) return "RESET";
244 if (n == 1) return "BOLD";
245 if (n == 30) return "BLACK";
246 if (n == 31) return "RED";
247 if (n == 32) return "GREEN";
248 if (n == 33) return "YELLOW";
249 if (n == 34) return "BLUE";
250 if (n == 35) return "MAGENTA";
251 if (n == 36) return "CYAN";
252 if (n == 37) return "WHITE";
253 if (n == 40) return "BLACK";
254 if (n == 41) return "BRED";
255 if (n == 42) return "BGREEN";
256 if (n == 43) return "BYELLOW";
257 if (n == 44) return "BBLUE";
258 if (n == 45) return "BMAGENTA";
259 if (n == 46) return "BCYAN";
260 if (n == 47) return "BWHITE";
263 while (match($0, /\x1b\[[0-9;]*m/) != 0) {
264 printf "%s<", substr($0, 1, RSTART-1);
265 codes = substr($0, RSTART+2, RLENGTH-3);
266 if (length(codes) == 0)
267 printf "%s", name(0)
268 else {
269 n = split(codes, ary, ";");
270 sep = "";
271 for (i = 1; i <= n; i++) {
272 printf "%s%s", sep, name(ary[i]);
273 sep = ";"
276 printf ">";
277 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
279 print
284 nul_to_q () {
285 perl -pe 'y/\000/Q/'
288 q_to_nul () {
289 perl -pe 'y/Q/\000/'
292 q_to_cr () {
293 tr Q '\015'
296 q_to_tab () {
297 tr Q '\011'
300 append_cr () {
301 sed -e 's/$/Q/' | tr Q '\015'
304 remove_cr () {
305 tr '\015' Q | sed -e 's/Q$//'
308 test_tick () {
309 if test -z "${test_tick+set}"
310 then
311 test_tick=1112911993
312 else
313 test_tick=$(($test_tick + 60))
315 GIT_COMMITTER_DATE="$test_tick -0700"
316 GIT_AUTHOR_DATE="$test_tick -0700"
317 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
320 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
322 # This will commit a file with the given contents and the given commit
323 # message. It will also add a tag with <message> as name.
325 # Both <file> and <contents> default to <message>.
327 test_commit () {
328 file=${2:-"$1.t"}
329 echo "${3-$1}" > "$file" &&
330 git add "$file" &&
331 test_tick &&
332 git commit -m "$1" &&
333 git tag "$1"
336 # Call test_merge with the arguments "<message> <commit>", where <commit>
337 # can be a tag pointing to the commit-to-merge.
339 test_merge () {
340 test_tick &&
341 git merge -m "$1" "$2" &&
342 git tag "$1"
345 # This function helps systems where core.filemode=false is set.
346 # Use it instead of plain 'chmod +x' to set or unset the executable bit
347 # of a file in the working directory and add it to the index.
349 test_chmod () {
350 chmod "$@" &&
351 git update-index --add "--chmod=$@"
354 # Use test_set_prereq to tell that a particular prerequisite is available.
355 # The prerequisite can later be checked for in two ways:
357 # - Explicitly using test_have_prereq.
359 # - Implicitly by specifying the prerequisite tag in the calls to
360 # test_expect_{success,failure,code}.
362 # The single parameter is the prerequisite tag (a simple word, in all
363 # capital letters by convention).
365 test_set_prereq () {
366 satisfied="$satisfied$1 "
368 satisfied=" "
370 test_have_prereq () {
371 # prerequisites can be concatenated with ','
372 save_IFS=$IFS
373 IFS=,
374 set -- $*
375 IFS=$save_IFS
377 total_prereq=0
378 ok_prereq=0
379 missing_prereq=
381 for prerequisite
383 total_prereq=$(($total_prereq + 1))
384 case $satisfied in
385 *" $prerequisite "*)
386 ok_prereq=$(($ok_prereq + 1))
389 # Keep a list of missing prerequisites
390 if test -z "$missing_prereq"
391 then
392 missing_prereq=$prerequisite
393 else
394 missing_prereq="$prerequisite,$missing_prereq"
396 esac
397 done
399 test $total_prereq = $ok_prereq
402 # You are not expected to call test_ok_ and test_failure_ directly, use
403 # the text_expect_* functions instead.
405 test_ok_ () {
406 test_success=$(($test_success + 1))
407 say_color "" "ok $test_count - $@"
410 test_failure_ () {
411 test_failure=$(($test_failure + 1))
412 say_color error "not ok - $test_count $1"
413 shift
414 echo "$@" | sed -e 's/^/# /'
415 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
418 test_known_broken_ok_ () {
419 test_fixed=$(($test_fixed+1))
420 say_color "" "ok $test_count - $@ # TODO known breakage"
423 test_known_broken_failure_ () {
424 test_broken=$(($test_broken+1))
425 say_color skip "not ok $test_count - $@ # TODO known breakage"
428 test_debug () {
429 test "$debug" = "" || eval "$1"
432 test_run_ () {
433 test_cleanup=:
434 eval >&3 2>&4 "$1"
435 eval_ret=$?
436 eval >&3 2>&4 "$test_cleanup"
437 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
438 echo ""
440 return 0
443 test_skip () {
444 test_count=$(($test_count+1))
445 to_skip=
446 for skp in $GIT_SKIP_TESTS
448 case $this_test.$test_count in
449 $skp)
450 to_skip=t
451 break
452 esac
453 done
454 if test -z "$to_skip" && test -n "$prereq" &&
455 ! test_have_prereq "$prereq"
456 then
457 to_skip=t
459 case "$to_skip" in
461 of_prereq=
462 if test "$missing_prereq" != "$prereq"
463 then
464 of_prereq=" of $prereq"
467 say_color skip >&3 "skipping test: $@"
468 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
469 : true
472 false
474 esac
477 test_expect_failure () {
478 test "$#" = 3 && { prereq=$1; shift; } || prereq=
479 test "$#" = 2 ||
480 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
481 if ! test_skip "$@"
482 then
483 say >&3 "checking known breakage: $2"
484 test_run_ "$2"
485 if [ "$?" = 0 -a "$eval_ret" = 0 ]
486 then
487 test_known_broken_ok_ "$1"
488 else
489 test_known_broken_failure_ "$1"
492 echo >&3 ""
495 test_expect_success () {
496 test "$#" = 3 && { prereq=$1; shift; } || prereq=
497 test "$#" = 2 ||
498 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
499 if ! test_skip "$@"
500 then
501 say >&3 "expecting success: $2"
502 test_run_ "$2"
503 if [ "$?" = 0 -a "$eval_ret" = 0 ]
504 then
505 test_ok_ "$1"
506 else
507 test_failure_ "$@"
510 echo >&3 ""
513 test_expect_code () {
514 test "$#" = 4 && { prereq=$1; shift; } || prereq=
515 test "$#" = 3 ||
516 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
517 if ! test_skip "$@"
518 then
519 say >&3 "expecting exit code $1: $3"
520 test_run_ "$3"
521 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
522 then
523 test_ok_ "$2"
524 else
525 test_failure_ "$@"
528 echo >&3 ""
531 # test_external runs external test scripts that provide continuous
532 # test output about their progress, and succeeds/fails on
533 # zero/non-zero exit code. It outputs the test output on stdout even
534 # in non-verbose mode, and announces the external script with "# run
535 # <n>: ..." before running it. When providing relative paths, keep in
536 # mind that all scripts run in "trash directory".
537 # Usage: test_external description command arguments...
538 # Example: test_external 'Perl API' perl ../path/to/test.pl
539 test_external () {
540 test "$#" = 4 && { prereq=$1; shift; } || prereq=
541 test "$#" = 3 ||
542 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
543 descr="$1"
544 shift
545 if ! test_skip "$descr" "$@"
546 then
547 # Announce the script to reduce confusion about the
548 # test output that follows.
549 say_color "" "# run $test_count: $descr ($*)"
550 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
551 # to be able to use them in script
552 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
553 # Run command; redirect its stderr to &4 as in
554 # test_run_, but keep its stdout on our stdout even in
555 # non-verbose mode.
556 "$@" 2>&4
557 if [ "$?" = 0 ]
558 then
559 if test $test_external_has_tap -eq 0; then
560 test_ok_ "$descr"
561 else
562 say_color "" "# test_external test $descr was ok"
563 test_success=$(($test_success + 1))
565 else
566 if test $test_external_has_tap -eq 0; then
567 test_failure_ "$descr" "$@"
568 else
569 say_color error "# test_external test $descr failed: $@"
570 test_failure=$(($test_failure + 1))
576 # Like test_external, but in addition tests that the command generated
577 # no output on stderr.
578 test_external_without_stderr () {
579 # The temporary file has no (and must have no) security
580 # implications.
581 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
582 stderr="$tmp/git-external-stderr.$$.tmp"
583 test_external "$@" 4> "$stderr"
584 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
585 descr="no stderr: $1"
586 shift
587 say >&3 "# expecting no stderr from previous command"
588 if [ ! -s "$stderr" ]; then
589 rm "$stderr"
591 if test $test_external_has_tap -eq 0; then
592 test_ok_ "$descr"
593 else
594 say_color "" "# test_external_without_stderr test $descr was ok"
595 test_success=$(($test_success + 1))
597 else
598 if [ "$verbose" = t ]; then
599 output=`echo; echo "# Stderr is:"; cat "$stderr"`
600 else
601 output=
603 # rm first in case test_failure exits.
604 rm "$stderr"
605 if test $test_external_has_tap -eq 0; then
606 test_failure_ "$descr" "$@" "$output"
607 else
608 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
609 test_failure=$(($test_failure + 1))
614 # debugging-friendly alternatives to "test [-f|-d|-e]"
615 # The commands test the existence or non-existence of $1. $2 can be
616 # given to provide a more precise diagnosis.
617 test_path_is_file () {
618 if ! [ -f "$1" ]
619 then
620 echo "File $1 doesn't exist. $*"
621 false
625 test_path_is_dir () {
626 if ! [ -d "$1" ]
627 then
628 echo "Directory $1 doesn't exist. $*"
629 false
633 test_path_is_missing () {
634 if [ -e "$1" ]
635 then
636 echo "Path exists:"
637 ls -ld "$1"
638 if [ $# -ge 1 ]; then
639 echo "$*"
641 false
646 # This is not among top-level (test_expect_success | test_expect_failure)
647 # but is a prefix that can be used in the test script, like:
649 # test_expect_success 'complain and die' '
650 # do something &&
651 # do something else &&
652 # test_must_fail git checkout ../outerspace
655 # Writing this as "! git checkout ../outerspace" is wrong, because
656 # the failure could be due to a segv. We want a controlled failure.
658 test_must_fail () {
659 "$@"
660 exit_code=$?
661 if test $exit_code = 0; then
662 echo >&2 "test_must_fail: command succeeded: $*"
663 return 1
664 elif test $exit_code -gt 129 -a $exit_code -le 192; then
665 echo >&2 "test_must_fail: died by signal: $*"
666 return 1
667 elif test $exit_code = 127; then
668 echo >&2 "test_must_fail: command not found: $*"
669 return 1
671 return 0
674 # Similar to test_must_fail, but tolerates success, too. This is
675 # meant to be used in contexts like:
677 # test_expect_success 'some command works without configuration' '
678 # test_might_fail git config --unset all.configuration &&
679 # do something
682 # Writing "git config --unset all.configuration || :" would be wrong,
683 # because we want to notice if it fails due to segv.
685 test_might_fail () {
686 "$@"
687 exit_code=$?
688 if test $exit_code -gt 129 -a $exit_code -le 192; then
689 echo >&2 "test_might_fail: died by signal: $*"
690 return 1
691 elif test $exit_code = 127; then
692 echo >&2 "test_might_fail: command not found: $*"
693 return 1
695 return 0
698 # test_cmp is a helper function to compare actual and expected output.
699 # You can use it like:
701 # test_expect_success 'foo works' '
702 # echo expected >expected &&
703 # foo >actual &&
704 # test_cmp expected actual
707 # This could be written as either "cmp" or "diff -u", but:
708 # - cmp's output is not nearly as easy to read as diff -u
709 # - not all diff versions understand "-u"
711 test_cmp() {
712 $GIT_TEST_CMP "$@"
715 # This function can be used to schedule some commands to be run
716 # unconditionally at the end of the test to restore sanity:
718 # test_expect_success 'test core.capslock' '
719 # git config core.capslock true &&
720 # test_when_finished "git config --unset core.capslock" &&
721 # hello world
724 # That would be roughly equivalent to
726 # test_expect_success 'test core.capslock' '
727 # git config core.capslock true &&
728 # hello world
729 # git config --unset core.capslock
732 # except that the greeting and config --unset must both succeed for
733 # the test to pass.
735 test_when_finished () {
736 test_cleanup="{ $*
737 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
740 # Most tests can use the created repository, but some may need to create more.
741 # Usage: test_create_repo <directory>
742 test_create_repo () {
743 test "$#" = 1 ||
744 error "bug in the test script: not 1 parameter to test-create-repo"
745 repo="$1"
746 mkdir -p "$repo"
748 cd "$repo" || error "Cannot setup test environment"
749 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
750 error "cannot run git init -- have you built things yet?"
751 mv .git/hooks .git/hooks-disabled
752 ) || exit
755 test_done () {
756 GIT_EXIT_OK=t
758 if test -z "$HARNESS_ACTIVE"; then
759 test_results_dir="$TEST_DIRECTORY/test-results"
760 mkdir -p "$test_results_dir"
761 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
763 echo "total $test_count" >> $test_results_path
764 echo "success $test_success" >> $test_results_path
765 echo "fixed $test_fixed" >> $test_results_path
766 echo "broken $test_broken" >> $test_results_path
767 echo "failed $test_failure" >> $test_results_path
768 echo "" >> $test_results_path
771 if test "$test_fixed" != 0
772 then
773 say_color pass "# fixed $test_fixed known breakage(s)"
775 if test "$test_broken" != 0
776 then
777 say_color error "# still have $test_broken known breakage(s)"
778 msg="remaining $(($test_count-$test_broken)) test(s)"
779 else
780 msg="$test_count test(s)"
782 case "$test_failure" in
784 # Maybe print SKIP message
785 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
787 if test $test_external_has_tap -eq 0; then
788 say_color pass "# passed all $msg"
789 say "1..$test_count$skip_all"
792 test -d "$remove_trash" &&
793 cd "$(dirname "$remove_trash")" &&
794 rm -rf "$(basename "$remove_trash")"
796 exit 0 ;;
799 if test $test_external_has_tap -eq 0; then
800 say_color error "# failed $test_failure among $msg"
801 say "1..$test_count"
804 exit 1 ;;
806 esac
809 # Test the binaries we have just built. The tests are kept in
810 # t/ subdirectory and are run in 'trash directory' subdirectory.
811 if test -z "$TEST_DIRECTORY"
812 then
813 # We allow tests to override this, in case they want to run tests
814 # outside of t/, e.g. for running tests on the test library
815 # itself.
816 TEST_DIRECTORY=$(pwd)
818 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
820 if test -n "$valgrind"
821 then
822 make_symlink () {
823 test -h "$2" &&
824 test "$1" = "$(readlink "$2")" || {
825 # be super paranoid
826 if mkdir "$2".lock
827 then
828 rm -f "$2" &&
829 ln -s "$1" "$2" &&
830 rm -r "$2".lock
831 else
832 while test -d "$2".lock
834 say "Waiting for lock on $2."
835 sleep 1
836 done
841 make_valgrind_symlink () {
842 # handle only executables
843 test -x "$1" || return
845 base=$(basename "$1")
846 symlink_target=$GIT_BUILD_DIR/$base
847 # do not override scripts
848 if test -x "$symlink_target" &&
849 test ! -d "$symlink_target" &&
850 test "#!" != "$(head -c 2 < "$symlink_target")"
851 then
852 symlink_target=../valgrind.sh
854 case "$base" in
855 *.sh|*.perl)
856 symlink_target=../unprocessed-script
857 esac
858 # create the link, or replace it if it is out of date
859 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
862 # override all git executables in TEST_DIRECTORY/..
863 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
864 mkdir -p "$GIT_VALGRIND"/bin
865 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
867 make_valgrind_symlink $file
868 done
869 OLDIFS=$IFS
870 IFS=:
871 for path in $PATH
873 ls "$path"/git-* 2> /dev/null |
874 while read file
876 make_valgrind_symlink "$file"
877 done
878 done
879 IFS=$OLDIFS
880 PATH=$GIT_VALGRIND/bin:$PATH
881 GIT_EXEC_PATH=$GIT_VALGRIND/bin
882 export GIT_VALGRIND
883 elif test -n "$GIT_TEST_INSTALLED" ; then
884 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
885 error "Cannot run git from $GIT_TEST_INSTALLED."
886 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
887 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
888 else # normal case, use ../bin-wrappers only unless $with_dashes:
889 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
890 if ! test -x "$git_bin_dir/git" ; then
891 if test -z "$with_dashes" ; then
892 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
894 with_dashes=t
896 PATH="$git_bin_dir:$PATH"
897 GIT_EXEC_PATH=$GIT_BUILD_DIR
898 if test -n "$with_dashes" ; then
899 PATH="$GIT_BUILD_DIR:$PATH"
902 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
903 unset GIT_CONFIG
904 GIT_CONFIG_NOSYSTEM=1
905 GIT_CONFIG_NOGLOBAL=1
906 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
908 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
910 if test -z "$GIT_TEST_CMP"
911 then
912 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
913 then
914 GIT_TEST_CMP="$DIFF -c"
915 else
916 GIT_TEST_CMP="$DIFF -u"
920 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
921 export GITPERLLIB
922 test -d "$GIT_BUILD_DIR"/templates/blt || {
923 error "You haven't built things yet, have you?"
926 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
927 then
928 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
929 export GITPYTHONLIB
930 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
931 error "You haven't built git_remote_helpers yet, have you?"
935 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
936 echo >&2 'You need to build test-chmtime:'
937 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
938 exit 1
941 # Test repository
942 test="trash directory.$(basename "$0" .sh)"
943 test -n "$root" && test="$root/$test"
944 case "$test" in
945 /*) TRASH_DIRECTORY="$test" ;;
946 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
947 esac
948 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
949 rm -fr "$test" || {
950 GIT_EXIT_OK=t
951 echo >&5 "FATAL: Cannot prepare test area"
952 exit 1
955 test_create_repo "$test"
956 # Use -P to resolve symlinks in our working directory so that the cwd
957 # in subprocesses like git equals our $PWD (for pathname comparisons).
958 cd -P "$test" || exit 1
960 HOME=$(pwd)
961 export HOME
963 this_test=${0##*/}
964 this_test=${this_test%%-*}
965 for skp in $GIT_SKIP_TESTS
967 case "$this_test" in
968 $skp)
969 say_color skip >&3 "skipping test $this_test altogether"
970 skip_all="skip all tests in $this_test"
971 test_done
972 esac
973 done
975 # Provide an implementation of the 'yes' utility
976 yes () {
977 if test $# = 0
978 then
980 else
981 y="$*"
984 while echo "$y"
987 done
990 # Fix some commands on Windows
991 case $(uname -s) in
992 *MINGW*)
993 # Windows has its own (incompatible) sort and find
994 sort () {
995 /usr/bin/sort "$@"
997 find () {
998 /usr/bin/find "$@"
1000 sum () {
1001 md5sum "$@"
1003 # git sees Windows-style pwd
1004 pwd () {
1005 builtin pwd -W
1007 # no POSIX permissions
1008 # backslashes in pathspec are converted to '/'
1009 # exec does not inherit the PID
1012 test_set_prereq POSIXPERM
1013 test_set_prereq BSLASHPSPEC
1014 test_set_prereq EXECKEEPSPID
1016 esac
1018 test -z "$NO_PERL" && test_set_prereq PERL
1019 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1021 # test whether the filesystem supports symbolic links
1022 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1023 rm -f y
1025 # When the tests are run as root, permission tests will report that
1026 # things are writable when they shouldn't be.
1027 test -w / || test_set_prereq SANITY